/*
 * Demonstration: Shopping Cart
 * in Flash MX 2004 
 * by PhilFlash - http://philflash.inway.fr
 * Fvrier 2005
 *
 */

import mx.controls.Button;
import mx.controls.Alert;
import mx.controls.TextInput;
import mx.controls.Label;
import mx.controls.DataGrid;
import mx.styles.CSSStyleDeclaration;

import mx.data.components.DataSet;
import mx.data.components.XMLConnector;

import mx.data.components.datasetclasses.DataSetError;
import mx.data.to.ValueListIterator;

import mx.utils.Delegate;

class form.CartForm extends mx.screens.Form {


	public var total_la:Label;
	
	public var panier_ds:DataSet;
	public var panier_dg:DataGrid;
	
	public var addItemButton:Button;
	public var name_la:TextInput;
	public var price_la:TextInput;
	
	public var resultButton:Button;
	
	private var initPanier:Boolean = false;
	
		
	// Constructor
	public function CartForm() {}
	
	// -----  -----
	public function init():Void {
		super.init();
		addEventListener("reveal", onReveal);
	}

	// -----  -----	
	public function onLoad(obj:Object):Void {
		setVisible(false);
 		
 		// -- DataSet
		panier_ds.addEventListener("calcFields", Delegate.create(this, doCalcFields));
		panier_ds.addEventListener("modelChanged", Delegate.create(this, doShowTotal));	
		
		// -- Buttons
		addItemButton.addEventListener("click", Delegate.create(this, doAddItem));
		resultButton.addEventListener("click", Delegate.create(this, doResultAction));
		
 		// -- Labels		
		total_la.styleSheet = (rootForm).myappliStyleSheet;
		total_la.html = true;
		total_la.text = "";
		
		// -- DataGrid
		initStyleGrid(panier_dg);
		initColumnGrid(panier_dg); 
					
	}
	
	// -----  -----
	public function onReveal(obj:Object):Void {
 		
		if (!initPanier) {
			var items:Array = [ {productname:"Item 1", itemprice:12.00, quantity:1},
								{productname:"Item 2", itemprice:10.50, quantity:3},
								{productname:"Item 3", itemprice:45.25, quantity:2}];
			panier_ds.dataProvider = items;
			initPanier = true;
		}
	}
	
	// -----  -----
	public function initStyleGrid(datagrid:DataGrid):Void {
		datagrid.editable = false;
		datagrid.multipleSelection = false; 
		
		datagrid.setRowHeight(40);
		datagrid.setStyle("vGridLines", false);
		
		// Header style
		var styleHeader:CSSStyleDeclaration= new mx.styles.CSSStyleDeclaration();
		styleHeader.styleName = "myHeader";
		styleHeader.fontFamily = "Verdana";
		styleHeader.fontSize = 11;
		styleHeader.fontWeight = "bold";
		styleHeader.textAlign = "left";
		styleHeader.color = 0x000064;
		_global.styles["myHeader"] = styleHeader;

		datagrid.setStyle("headerStyle", styleHeader);
		//datagrid.setStyle("headerColor", 0xFFFFFF);

		datagrid.setHeaderHeight(25);
		
		// --
		//datagrid.setStyle("borderStyle", "none");
		datagrid.vScrollPolicy = "auto";
		
		datagrid.setStyle("alternatingRowColors", Array(0xFFFFFF, 0xF8FAFB));
	}

	// -----  -----
		
	public function initColumnGrid(datagrid:DataGrid):Void {
		var newColumn:mx.controls.gridclasses.DataGridColumn;
		
		datagrid.removeAllColumns();
  		var totalWidth:Number = 0;
  
		newColumn = new mx.controls.gridclasses.DataGridColumn("productname");
		newColumn.headerText = "Product:";
		newColumn.editable = false;
		newColumn.resizable = true;
		newColumn.sortable = true;
		newColumn.width = 170;
		datagrid.addColumn(newColumn);
		totalWidth += newColumn.width;
		
		newColumn = new mx.controls.gridclasses.DataGridColumn("quantity");
		newColumn.headerText = "Quantity:";
		newColumn.editable = false;
		newColumn.resizable = true;
		newColumn.sortable = true;
		newColumn.width = 90;
		newColumn.cellRenderer = "QuantityCellRenderer";
		datagrid.addColumn(newColumn);
		totalWidth += newColumn.width;	
		
		newColumn = new mx.controls.gridclasses.DataGridColumn("itemprice");
		newColumn.headerText = "Unit Price:";
		newColumn.editable = false;
		newColumn.resizable = true;
		newColumn.sortable = true;
		newColumn.width = 100;
		datagrid.addColumn(newColumn);
		totalWidth += newColumn.width;	
		
		newColumn = new mx.controls.gridclasses.DataGridColumn("");
		newColumn.headerText = "  ";
		newColumn.editable = false;
		newColumn.resizable = true;
		newColumn.sortable = false;
		newColumn.cellRenderer = "RemoveCellRenderer";
		newColumn.width = 40;
		datagrid.addColumn(newColumn);
		totalWidth += newColumn.width;
		
		newColumn = new mx.controls.gridclasses.DataGridColumn("itemtotal");
		newColumn.headerText = "Subtotal:";
		newColumn.editable = false;
		newColumn.resizable = true;
		newColumn.sortable = true;
		newColumn.width = datagrid.width-totalWidth-18; // 18 for scrollbar
		datagrid.addColumn(newColumn);
		
		// itemprice
		var col = datagrid.getColumnAt(2);
		col.setStyle("textAlign", "right");
		// itemtotal
		var col = datagrid.getColumnAt(4);
		col.setStyle("textAlign", "right");
	}

	// -----   -----	
	public function doCalcFields(eventObj:Object):Void {	
		var target = eventObj.target;
		target.itemtotal = target.quantity * target.itemprice;
	}
	
 	// -----   -----
	public function doResultAction(evt:Object):Void {
		setVisible(false);
		(rootForm).result.setVisible(true);
	}

 	// -----   -----	
	public function doShowTotal():Void {	
		var total:Number = doComputeTotal();
		total_la.text = "<total>Total:  "+formatNumber(total,2)+"</total>";
	}
	
	public function doComputeTotal():Number {	
 		var dataset = panier_ds;
		var len = dataset.length;
		var total:Number = 0;
		for (var i:Number = 0; i < len; i++) {
			var item:Object = dataset.items[i];
			total += item.itemtotal;
		}
		return total;
	}

 	// -----   -----
	public function doAddItem(eventObj:Object):Void {	
		var label = name_la.text;
		var strPrice = price_la.text;
		
		var price = parseFloat(strPrice);
		if (label == "" || isNaN(price) || price <= 0) return;
		
		panier_ds.addItem({productname:label, itemprice:price, quantity:1});
	}	
	
 	// -----  -----
 	// Generate XML
	public function cartToXML():XML {
		var document:XML = new XML("<?xml version=\"1.0\" encoding=\"UTF-8\" ?><cart></cart>");
		var rootNode = document.firstChild;  
		
		// attributes for rootNode
		rootNode.attributes.customerId = "philflash";
		rootNode.attributes.total = formatNumber(doComputeTotal(),2);
		
		// item
		var dpCursor:ValueListIterator = panier_ds.getIterator();
		while (dpCursor.hasNext()) {
			dpCursor.next();
			var currentItem = dpCursor.getCurrentItem();

			var node = document.createElement("itemcart");
			// Ordre inverse pour avoir bon ordre dans attributs
			node.attributes.subtotal = currentItem.itemtotal;
			node.attributes.quantity = currentItem.quantity;			
			node.attributes.unitprice = currentItem.itemprice;			
			node.attributes.name = currentItem.productname;
			
			rootNode.appendChild(node);
		}
		return document;
	}
	
	// -----  -----
	public function formatNumber(value:Number, precision:Number):String {
		var strValue:String;
		if( precision > 0 ) {
			var perc:Number = Math.pow( 10, precision );
			strValue = ( Math.round( value * perc ) / perc ).toString();
			if( strValue.length > 0 ) {
				var index = strValue.lastIndexOf( '.' );
				var zCnt = 0;
				if( index < 0 ) {
					strValue += ".";
					zCnt = precision;
				}
				else
					zCnt = precision -( strValue.length- ( index +1 ));
				// add the zeros on
				strValue = strValue + "0000000000000000000000000000".substring( 0, zCnt );
			}
		}
		else
			strValue = Math.round( value ).toString(); // trunc to 0 precision	
		return strValue;
	}
	
}
    
